<?php

namespace Fastrack\Content;


use Fastrack\Utilities\Slug;
use PlatoCreative\Imgix\Imgix;
use SilverStripe\AssetAdmin\Forms\UploadField;
use SilverStripe\Forms\FieldList;
use SilverStripe\Forms\HTMLEditor\HTMLEditorField;
use SilverStripe\Forms\TextareaField;
use SilverStripe\Forms\TextField;
use SilverStripe\ORM\DataExtension;

class ContentExtension extends DataExtension
{

	private static array $db = [
		'Slug' => 'Varchar',
		'Excerpt' => 'Text',
		'Content' => 'HTMLText'
	];

	private static array $has_one = [
		'Image' => Imgix::class,
	];

	private static array $owns = [
		'Image'
	];

	private static array $translate = [
		'Excerpt',
		'Content',
	];


	public function updateCMSFields(FieldList $fields)
	{
		$fields->insertAfter('Name', TextField::create('Slug'));
		$fields->addFieldsToTab('Root.Content', [
			new UploadField('Image'),
			TextareaField::create('Excerpt'),
			HTMLEditorField::create('Content', 'Content'),
		]);
	}

	public function onBeforeWrite()
	{
		$this->owner->Slug = Slug::generateSlug($this->owner->Name, $this->owner->Slug);
		parent::onBeforeWrite();
	}

}
